// chg2.cpp

#include <iostream>
#include <stdexcept>
#include <ginac/ginac.h>
#include "kummer.h"
using namespace std;
using namespace GiNaC;

int main(void)
{
	int i;
	bool flag;
	string buffer;
	numeric f_coeff[7], xi[5];

//  To change precision, comment out the following and change the value.
//	Digits = 17;
	
	try {
	for(i=6; i >= 0; i--) {
		do {
		cout << "f" << i << ": " << flush;
		cin >> buffer;
		f_coeff[i] = buffer.c_str();
		} while(!f_coeff[i].is_integer());
	}
	} catch(exception &p) {
		cerr << p.what() << endl;
		return 1;
	}

	kummer k(f_coeff);
	
	for(;;) {
		try {
		for(i = 1; i <= 4; i++) {
			do {
			cout << "xi" << i << ": " << flush;
			cin >> buffer;
			xi[i] = buffer.c_str();
			} while(!xi[i].is_rational());
		}
		} catch(exception &p) {
			cerr << p.what() << endl;
			return 1;
		}
		
		flag = false;
		for(i = 1; i <= 4; i++) {
			flag = flag || !(xi[i].is_zero());
		}
		if(!flag) {
			return 0;
		}
		kummer_point p(xi+1);
	
		if(!is_on_kummer(k,p)) {
			cout << "This point is not on the Kummer surface." << endl;
			continue;
		}
		kummer_point q(p.normalize());
		
		
		cout << "naive height: " << q.naive_height() << endl;
		cout << "canonical height computing..." << endl;
		cout << "canonical height: " << q.canonical_height(k) << endl;
		cout << "canonical height computing (Stoll's algorithm)..." << endl;
		cout << "canonical height: " << q.canonical_height_Stoll(k) << endl;
	}

	return 0;
}
